<ion-content>
    <ion-grid class="register pt-15 ion-justify-content-between">
        <div>
            <!-- Logo -->
            <ion-row class="ion-justify-content-center mt-30">
                <ion-col size="auto" class="ion-no-padding">
                    <app-img
                        src="assets/img/kymia.svg"
                        alt="Kymia"
                        title="Kymia"
                        class="width-41 height-50 block"
                        [errorSrc]="cardMedia"
                    >
                    </app-img>
                </ion-col>
            </ion-row>
            <!-- Title -->
            <div class="ion-text-center">
                <ion-text class="size-36 weight-700" color="primary"
                    >Inscription
                </ion-text>
                <ion-text class="block size-14 mt-10" color="dove-black"
                    >Inscrivez-vous pour continuer
                </ion-text>
            </div>
            <!-- Form -->
            <form
                [formGroup]="registerForm"
                name="registerForm"
                novalidate
                class="ion-padding"
            >
                <ion-row
                    class="ion-align-items-center pr-10 py-5 mb-3 radius-5 has-border-blue-misty border-solid border-1"
                >
                    <ion-col
                        size="1.5"
                        class="ion-no-padding ion-text-center pl-10"
                    >
                        <ion-icon
                            name="person-circle"
                            fill="clear"
                            class="size-20"
                            color="dove-grey"
                        ></ion-icon>
                    </ion-col>
                    <ion-col size="10.5">
                        <ion-input
                            type="text"
                            data-testid="lastname"
                            color="medium"
                            class="size-14 weight-500 ion-padding-start height-32 radius-7 has-border-grey-slate border-solid border-1"
                            placeholder="Nom *"
                            formControlName="lastname"
                            [ngClass]="{ 'is-invalid': submit.getValue() && f.lastname.errors }"
                        >
                        </ion-input>
                        <!-- Errors -->
                        <div
                            *ngIf="registerForm.controls.lastname.value && f.lastname.errors"
                            data-testid="lastname-errors"
                            class="size-12"
                        >
                            <ion-text
                                *ngIf="f.lastname.hasError('pattern'); else patternErrorLastname"
                                data-testid="lastname-number"
                                color="red"
                            >
                                {{ messages.mustContainLetters }}
                            </ion-text>
                            <ng-template #patternErrorLastname>
                                <ion-text
                                    *ngIf="f.lastname.hasError('minlength')"
                                    data-testid="lastname-missing-caracters"
                                    color="red"
                                >
                                    Le nom doit avoir au moins 2 caractères
                                </ion-text>
                            </ng-template>
                        </div>
                    </ion-col>
                </ion-row>

                <ion-row
                    class="ion-align-items-center pr-10 py-5 mt-5 mb-3 radius-5 has-border-blue-misty border-solid border-1"
                >
                    <ion-col
                        size="1.5"
                        class="ion-no-padding ion-text-center pl-10"
                    >
                        <ion-icon
                            name="person-circle"
                            fill="clear"
                            class="size-20"
                            color="dove-grey"
                        ></ion-icon>
                    </ion-col>
                    <ion-col size="10.5">
                        <ion-input
                            type="text"
                            data-testid="firstname"
                            color="medium"
                            class="size-14 weight-500 ion-padding-start height-32 radius-7 has-border-grey-slate border-solid border-1"
                            placeholder="Prénom *"
                            formControlName="firstname"
                            [ngClass]="{ 'is-invalid': submit.getValue() && f.firstname.errors }"
                        >
                        </ion-input>
                        <!-- Errors -->
                        <div
                            *ngIf="registerForm.controls.firstname.value && f.firstname.errors"
                            data-testid="firstname-errors"
                            class="mb-5 size-12"
                        >
                            <ion-text
                                *ngIf="f.firstname.hasError('pattern'); else patternErrorFirstname"
                                data-testid="firstname-number"
                                color="red"
                            >
                                {{messages.mustContainLetters}}
                            </ion-text>
                            <ng-template #patternErrorFirstname>
                                <ion-text
                                    *ngIf="f.firstname.hasError('minlength')"
                                    data-testid="firstname-missing-caracters"
                                    color="red"
                                >
                                    Le prénom doit avoir au moins 2 caractères
                                </ion-text>
                            </ng-template>
                        </div>
                    </ion-col>
                </ion-row>

                <ion-row
                    class="ion-align-items-center pr-10 py-5 radius-5 has-border-blue-misty border-solid border-1"
                >
                    <ion-col
                        size="1.5"
                        class="ion-no-padding ion-text-center pl-10"
                    >
                        <ion-icon
                            name="calendar"
                            fill="clear"
                            class="size-20"
                            color="dove-grey"
                        ></ion-icon>
                    </ion-col>
                    <ion-col size="10.5">
                        <div
                            class="size-14 weight-500 radius-7 has-border-grey-slate border-solid border-1"
                        >
                            <ion-datetime-button
                                class="border-0 ion-justify-content-start height-32"
                                datetime="birthdate"
                            >
                                <span slot="date-target" class="size-14">
                                    <ion-text
                                        *ngIf="registerForm.controls.birthdate.value; else placeholder"
                                        color="medium"
                                    >
                                        {{ registerForm.controls.birthdate.value
                                        | date : 'dd MMM YYYY'}}
                                    </ion-text>
                                    <ng-template #placeholder>
                                        <ion-label color="medium">
                                            Date de naissance (Facultatif)
                                        </ion-label>
                                    </ng-template>
                                </span>
                            </ion-datetime-button>
                            <ion-modal [keepContentsMounted]="true">
                                <ng-template>
                                    <ion-datetime
                                        presentation="date"
                                        [showDefaultButtons]="true"
                                        id="birthdate"
                                        formControlName="birthdate"
                                        data-testid="birthdate"
                                        displayFormat="YYYY-MM-DD"
                                    ></ion-datetime>
                                </ng-template>
                            </ion-modal>
                        </div>
                    </ion-col>
                </ion-row>

                <!-- Phone input -->
                <ion-row
                    class="ion-align-items-center ion-nowrap pr-10 py-5 mt-5 mb-3 radius-5 has-border-blue-misty border-solid border-1"
                >
                    <ion-col
                        size="1.5"
                        class="ion-no-padding ion-text-center pl-10"
                    >
                        <ion-icon
                            name="phone-portrait"
                            fill="clear"
                            class="size-20"
                            color="dove-grey"
                        ></ion-icon>
                    </ion-col>
                    <ion-col size="10.5">
                        <div
                            class="flex pl-12 ion-align-items-center size-14 weight-500 radius-7 has-border-grey-slate border-solid border-1"
                            [ngClass]="{ 'is-invalid': submit.getValue() && f.phone.errors }"
                        >
                            <app-phone-indicator
                                class="is-medium"
                            ></app-phone-indicator>
                            <ion-input
                                placeholder="Numéro de téléphone"
                                color="medium"
                                formControlName="phone"
                                data-testid="phone"
                                type="number"
                                class="height-32"
                            >
                            </ion-input>
                        </div>
                        <!-- Errors -->
                        <ion-text
                            *ngIf="registerForm.controls.phone.value && f.phone.errors && f.phone.hasError('pattern')"
                            class="block mb-5 size-12"
                            data-testid="phone-errors"
                            color="red"
                        >
                            {{messages.phoneError}}
                        </ion-text>
                    </ion-col>
                </ion-row>
                <!-- Email input -->
                <ion-row
                    class="ion-align-items-center pr-10 py-5 radius-5 has-border-blue-misty border-solid border-1"
                >
                    <ion-col
                        size="1.5"
                        class="ion-no-padding ion-text-center pl-10"
                    >
                        <ion-icon
                            name="mail"
                            fill="clear"
                            class="size-20"
                            color="dove-grey"
                        ></ion-icon>
                    </ion-col>
                    <ion-col size="10.5">
                        <ion-input
                            type="email"
                            data-testid="register-email"
                            color="medium"
                            class="size-14 weight-500 ion-padding-start height-32 radius-7 has-border-grey-slate border-solid border-1"
                            placeholder="Adresse email"
                            formControlName="email"
                            [ngClass]="{ 'is-invalid': submit.getValue() && f?.email?.errors }"
                        >
                        </ion-input>
                        <ion-text
                            *ngIf="registerForm.controls.email.value && f.email.errors"
                            data-testid="invalid-email"
                            class="block size-12"
                            color="red"
                        >
                            Veuillez entrer un email correct
                        </ion-text>
                    </ion-col>
                </ion-row>

                <!-- Password input -->
                <ion-row
                    class="ion-align-items-center pr-10 py-5 mt-5 mb-3 radius-5 has-border-blue-misty border-solid border-1"
                >
                    <ion-col
                        size="1.5"
                        class="ion-no-padding ion-text-center pl-10"
                    >
                        <ion-icon
                            name="lock-closed"
                            fill="clear"
                            class="size-20"
                            color="dove-grey"
                        ></ion-icon>
                    </ion-col>
                    <ion-col size="10.5" class="ion-align-items-center">
                        <ion-row
                            class="register__password weight-500 height-32 radius-7 has-border-grey-slate border-solid border-1"
                        >
                            <ion-input
                                class="size-14 ion-padding-start height-32"
                                color="medium"
                                placeholder="Mot de passe"
                                [type]="showPassword ? 'text':'password'"
                                formControlName="password"
                                [ngClass]="{ 'is-invalid': submit.getValue() && f.password.errors }"
                                data-testid="register-password"
                            >
                            </ion-input>
                            <app-button
                                (click)="toggleShow()"
                                (keyPress)="toggleShow()"
                                color="light"
                                expand="full"
                                shape="round"
                                [icon]="showPassword ? 'eye-outline' : 'eye-off-outline'"
                                class="flex ion-align-items-center height-32 width-53"
                            >
                            </app-button>
                        </ion-row>
                        <!-- Errors -->
                        <div
                            *ngIf="registerForm.controls.password.value && f.password.errors"
                            data-testid="password-errors"
                            class="size-12"
                        >
                            <ion-text
                                *ngIf="f.password.hasError('minlength'); else patternErrorPassword"
                                data-testid="password-missing-caracters"
                                color="red"
                            >
                                Le mot de passe doit avoir au moins 8 caractères
                            </ion-text>
                            <ng-template #patternErrorPassword>
                                <ion-text
                                    *ngIf="f.password.hasError('pattern')"
                                    data-testid="password-special-character"
                                    color="red"
                                >
                                    Le mot de passe doit contenir des caractères
                                    spéciaux
                                </ion-text>
                            </ng-template>
                        </div>
                    </ion-col>
                </ion-row>

                <div class="ion-margin-bottom">
                    <!-- Terms checked -->
                    <ion-popover
                        [isOpen]="showConditions"
                        class="register__conditions"
                    >
                        <ng-template>
                            <app-popup-conditions></app-popup-conditions>
                        </ng-template>
                    </ion-popover>
                    <ion-row class="ion-nowrap ion-padding-top">
                        <ion-col
                            size="1.5"
                            class="ion-no-padding ion-text-center pl-12 pb-0 pt-5"
                        >
                            <ion-checkbox
                                formControlName="acceptTerms"
                                mode="md"
                                class="height-15 width-15"
                                data-testid="accept-terms"
                            ></ion-checkbox>
                        </ion-col>
                        <ion-col size="11" class="ion-no-padding">
                            <ion-text
                                class="register__conditions__text size-13 weight-600"
                                color="grey-dark"
                            >
                                J'accepte
                                <a
                                    (click)="openCondtions()"
                                    color="primary"
                                    data-testid="conditions"
                                >
                                    les conditions générales
                                </a>
                                et la politique de confidentialité
                            </ion-text>
                            <!-- Errors -->
                            <ion-text
                                *ngIf="submit.getValue() && f.acceptTerms.errors?.required"
                                color="red"
                                class="block mt-5 size-12"
                                data-testid="accept-terms-errors"
                            >
                                Veuillez accepter les termes
                            </ion-text>
                            <ion-text
                                *ngIf="error.getValue() && !submit.getValue()"
                                data-testid="server-errors"
                                class="block mt-50 weight-500 size-12"
                                color="red"
                            >
                                {{error.getValue()}}
                            </ion-text>
                        </ion-col>
                    </ion-row>
                </div>
                <!-- Submit button  -->
                <ion-row class="ion-justify-content-center mt-45">
                    <ion-col size="11">
                        <app-button
                            data-testid="signup"
                            title="Valider"
                            [loading]="loading.getValue()"
                            class="button--radius-8 size-16"
                            expand="full"
                            shape="round"
                            color="primary"
                            size="large"
                            (click)="onSubmit()"
                            (keyPress)="onSubmit()"
                            [disabled]="registerForm.invalid"
                        ></app-button>
                    </ion-col>
                </ion-row>
            </form>
        </div>
        <!-- link to login -->
        <ion-row class="ion-justify-content-center mt-30 mb-15">
            <ion-col size="auto" class="size-14">
                <ion-text class="weight-700 mr-5" color="medium">
                    Vous avez un compte ?</ion-text
                >
                <a
                    class="weight-700 is-primary"
                    routerLink="/login"
                    data-testid="login"
                >
                    Se connecter
                </a>
            </ion-col>
        </ion-row>
    </ion-grid>
</ion-content>
